import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class Aufgabe2_Kellerautomat {
    private static String[] words = {"ZZO", "ZZOZZOO", "ZZZOO", "ZZOO", "ZZOZZO", "ZOZ"};

    public static void main(String[] args) {
        for (String word : words) {
            calculate(word);
        }
    }

    public static int calculate(String word) {
        List<Character> wordChars = new ArrayList<>();
        for (char symbol : word.toCharArray()) {
            wordChars.add(symbol);
        }
        ArrayList<Integer> stack = new ArrayList<>();
        stack.add(-1);

        int state = 0; //case 0 - 5 = q0 - q5, case -1 = Abfallzustand
        char operator = '$';
        int firstNumber = 0;
        int secondNumber = 0;
        int result = -1;

        while (wordChars.size() > 0 || state >= 3) {
            char symbol;
            int stackSymbol = stack.remove(stack.size() - 1);
            switch (state) {
                case 0:
                    symbol = wordChars.remove(0);
                    if (!isOperator(symbol) && stackSymbol == -1) {
                        stack.add(-1);
                        stack.add(Character.getNumericValue(symbol));
                        state = 1;
                    } else {
                        dontAccept(word);
                        return -1;
                    }
                    break;
                case 1:
                    symbol = wordChars.remove(0);
                    if (!isOperator(symbol) && stackSymbol > -1) {
                        stack.add(stackSymbol);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else {
                        dontAccept(word);
                        return -1;
                    }
                    break;
                case 2:
                    symbol = wordChars.remove(0);
                    if (isOperator(symbol) && stackSymbol > -1) {
                        operator = symbol;
                        firstNumber = stackSymbol;
                        state = 3;
                    } else if (!isOperator(symbol) && stackSymbol > -1) {
                        stack.add(stackSymbol);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else if (!isOperator(symbol) && stackSymbol == -1) {
                        stack.add(-1);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else {
                        dontAccept(word);
                        return -1;
                    }
                    break;
                case 3:
                    if (stackSymbol > -1) {
                        secondNumber = stackSymbol;
                        stack.add(doOperation(operator, firstNumber, secondNumber));
                        state = 4;
                    } else {
                        dontAccept(word);
                        return -1;
                    }
                    break;
                case 4:
                    if (wordChars.size() > 0) {
                        symbol = wordChars.remove(0);
                        if (!isOperator(symbol) && stackSymbol > -1) {
                            stack.add(stackSymbol);
                            stack.add(Character.getNumericValue(symbol));
                            state = 2;
                        } else if (isOperator(symbol) && stackSymbol > -1) {
                            operator = symbol;
                            firstNumber = stackSymbol;
                            state = 3;
                        } else {
                            dontAccept(word);
                            return -1;
                        }
                    } else {
                        if (stackSymbol > -1) {
                            result = stackSymbol;
                            state = 5;
                        } else {
                            dontAccept(word);
                            return -1;
                        }
                    }
                    break;
                case 5:
                    if (stackSymbol == -1) {
                        stack.add(-1);
                        state = 6;
                    } else {
                        dontAccept(word);
                        return -1;
                    }
                    break;
                case 6:
                    accept(word, result);
                    return result;

            }
        }
        dontAccept(word);
        return -1;
    }

    private static void dontAccept(String word) {
        System.out.println("Word: " + word  + "\nnot accepted");
    }

    private static void accept(String word, int result) {
        System.out.println("Word: " + word  + "\naccepted\nResult " + result);
    }

    private static boolean isOperator(char symbol){
        return symbol == '+' || symbol == '*';
    }

    private static int doOperation(char operator, int firstNumber, int secondNumber){
        if(operator == '+'){
            return firstNumber + secondNumber;
        } else if(operator == '*'){
            return firstNumber * secondNumber;
        }
        return -1;
    }

}
